# peplink-api-client
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.1
- Package version: 1.0.0
- Generator version: 7.8.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import peplink_api_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import peplink_api_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import peplink_api_client
from peplink_api_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = peplink_api_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with peplink_api_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = peplink_api_client.DefaultApi(api_client)
    token_request = peplink_api_client.TokenRequest() # TokenRequest |  (optional)

    try:
        # Generate a new access token
        api_response = api_instance.api_auth_token_grant_post(token_request=token_request)
        print("The response of DefaultApi->api_auth_token_grant_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->api_auth_token_grant_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**api_auth_token_grant_post**](docs/DefaultApi.md#api_auth_token_grant_post) | **POST** /api/auth.token.grant | Generate a new access token
*DefaultApi* | [**api_status_wan_connection_get**](docs/DefaultApi.md#api_status_wan_connection_get) | **GET** /api/status.wan.connection | Get WAN status


## Documentation For Models

 - [BWAllowanceMonitorObj](docs/BWAllowanceMonitorObj.md)
 - [BandObj](docs/BandObj.md)
 - [CarrierObj](docs/CarrierObj.md)
 - [CellTowerObj](docs/CellTowerObj.md)
 - [GobiObj](docs/GobiObj.md)
 - [MEIDObj](docs/MEIDObj.md)
 - [ModemObj](docs/ModemObj.md)
 - [MonthlyAllowanceObj](docs/MonthlyAllowanceObj.md)
 - [RATObj](docs/RATObj.md)
 - [RemoteSIMObj](docs/RemoteSIMObj.md)
 - [RoamingObj](docs/RoamingObj.md)
 - [SIMGroupObj](docs/SIMGroupObj.md)
 - [SIMObj](docs/SIMObj.md)
 - [SignalObj](docs/SignalObj.md)
 - [TokenRequest](docs/TokenRequest.md)
 - [TokenResponse](docs/TokenResponse.md)
 - [WanStatusResponse](docs/WanStatusResponse.md)
 - [WanStatusResponseResponseValue](docs/WanStatusResponseResponseValue.md)
 - [WifiObj](docs/WifiObj.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




