# coding: utf-8

"""
    Peplink API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from peplink_api_client.models.monthly_allowance_obj import MonthlyAllowanceObj
from typing import Optional, Set
from typing_extensions import Self

class BWAllowanceMonitorObj(BaseModel):
    """
    BWAllowanceMonitorObj
    """ # noqa: E501
    enable: Optional[StrictBool] = None
    has_smtp: Optional[StrictBool] = Field(default=None, alias="hasSmtp")
    action: Optional[List[StrictStr]] = None
    start: Optional[Annotated[int, Field(le=28, strict=True, ge=0)]] = None
    monthly_allowance: Optional[MonthlyAllowanceObj] = Field(default=None, alias="monthlyAllowance")
    __properties: ClassVar[List[str]] = ["enable", "hasSmtp", "action", "start", "monthlyAllowance"]

    @field_validator('action')
    def action_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        for i in value:
            if i not in set(['email', 'disconnect', 'restrict']):
                raise ValueError("each list item must be one of ('email', 'disconnect', 'restrict')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BWAllowanceMonitorObj from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of monthly_allowance
        if self.monthly_allowance:
            _dict['monthlyAllowance'] = self.monthly_allowance.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BWAllowanceMonitorObj from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enable": obj.get("enable"),
            "hasSmtp": obj.get("hasSmtp"),
            "action": obj.get("action"),
            "start": obj.get("start"),
            "monthlyAllowance": MonthlyAllowanceObj.from_dict(obj["monthlyAllowance"]) if obj.get("monthlyAllowance") is not None else None
        })
        return _obj


